//WWW.MICRODESIGNER.IR
#include <mega32.h>
#include <alcd.h>
#include <delay.h>
#include <spi.h>
#include <stdio.h>
#include "mmclib/mmc.h"
void m_play(void);
void m_next(void);
void m_pause(void);
void m_back(void);

char buffread[512];
char a;
bit s=1;
int i;
unsigned long int m_begin=768,m_end=10016;
void main(void){

DDRB=(1<<DDB0)|(1<<DDB4)|(1<<DDB5)|(1<<DDB7)|(1<<DDB3);
DDRC=0X00;
PORTC=0XFF;
SPCR=0x50;
SPSR=0x01;
TCCR0=0x00;// TCCR0=0x00//TCCR0=0x69
TCNT0=0x00;
OCR0=0x00;
TIMSK=0x00;
lcd_init(16);

   while(s==1){
     s=mmc_init(); 
     lcd_gotoxy(0,0);
     lcd_putsf("searching mmc");
     }
   lcd_clear();
   lcd_gotoxy(0,0);
   lcd_putsf("card detect ok");     
   delay_ms(20);  
   lcd_clear();
   lcd_gotoxy(0,0);
   lcd_putsf("Searching");
   delay_us(20);
   lcd_gotoxy(0,1);
   lcd_putsf("music player"); 
   delay_ms(100);
 while(1){
   lcd_clear();
   lcd_gotoxy(0,0);
   lcd_putsf("press play key");
   delay_us(20);
   lcd_gotoxy(0,1);
   lcd_putsf(" music player");
  
  if(PINC.0==0){
  while(PINC.0==0);
  m_play();  
  }  

   }  

}
////////////////////////////////////////////
 void m_play(void){
 TCCR0=0x69;       
 lcd_clear();
 lcd_gotoxy(0,0);
 lcd_putsf("playing"); 
 delay_us(20);
 lcd_gotoxy(0,1);
 lcd_putsf("music player");
    while(1){
   mmc_read(m_begin,buffread);
       for(i=0;i<512;i++){
       
       while(!(TIFR&0X02));
       TIFR |=0X02; 
       OCR0=buffread[i];
        if(PINC.0==0){ 
        while(PINC.0==0);
        delay_ms(35);
        m_pause();
        }
        if(PINC.1==0){
        while(PINC.1==0);
        delay_ms(30);
        m_next();
        }
        if(PINC.2==0){
        while(PINC.2==0);
        delay_ms(30);
        m_back();
        }
        
       
      }
   m_begin++;
   if(m_begin==m_end) m_next();   
      
   }

 }   
 //////////////////////////////////
  void m_pause(void){
  TCCR0=0x00;
  lcd_clear();
  lcd_gotoxy(0,0);
  lcd_putsf("pause");
  delay_us(20);
  lcd_gotoxy(0,1);
  lcd_putsf("  music player"); 
     while(1){
     if(PINC.0==0){
     while(PINC.0==0);
     delay_ms(30);
     m_play();
     }
  }
 }     
 
 ///////////////////////////////////////
      void m_next(void){
      a++;
      if(a==8) a=1;
      
       switch(a){
       case 1:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");break;
       case 2:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("parandeh");lcd_gotoxy(0,1);lcd_putsf("playing 3:18");break; 
       case 3:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("delam gerefte");lcd_gotoxy(0,1);lcd_putsf("playing 3:43");break;  
       case 4:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("behesh begin");lcd_gotoxy(0,1);lcd_putsf("playing 1:19");break;
       case 5:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("venouse ziba");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
       case 6:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ibo allah allah");lcd_gotoxy(0,1);lcd_putsf("playing 3:38");break;
       case 7:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ah keshkam ");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
       default: m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");
         }

      }


    void m_back(void){
        a--;
        if(a==0) a=1;
       switch(a){
       case 1:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");break;
       case 2:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("parandeh");lcd_gotoxy(0,1);lcd_putsf("playing 3:18");break; 
       case 3:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("delam gerefte");lcd_gotoxy(0,1);lcd_putsf("playing 3:43");break;  
       case 4:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("behesh begin");lcd_gotoxy(0,1);lcd_putsf("playing 1:19");break;
       case 5:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("venouse ziba");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
       case 6:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ibo allah allah");lcd_gotoxy(0,1);lcd_putsf("playing 3:38");break;
       case 7:  m_begin=768;m_end=10016;lcd_clear();lcd_putsf("ah keshkam ");lcd_gotoxy(0,1);lcd_putsf("playing 4:32");break;
       default: m_begin=768;m_end=10016;lcd_clear();lcd_putsf("be kalam");lcd_gotoxy(0,1);lcd_putsf("playing 2:48");
         }

    
    
    }



